import React from "react"

import { DropdownButton, MenuItem } from "react-bootstrap"

import RefreshIndicator from "./refresh"

export default class SubtitlesButton extends React.PureComponent {
  constructor(props) {
    super(props);
    this.handleClick = this.handleClick.bind(this);
  }
  handleClick(e) {
    e.preventDefault();
    if (this.props.fetching) { return }

    // Refresh the subtitles
    this.props.refreshSubtitles(this.props.type, this.props.resourceID, this.props.season, this.props.episode);
  }
  render() {
    const btnSize = this.props.xs ? "xsmall" : "small";
    const subtitles = this.props.subtitles;
    const hasSubtitles = (subtitles !== undefined && subtitles !== null);
    return (
      <DropdownButton bsStyle="success" bsSize={btnSize} title="Subtitles" id="download-subtitles-button" dropup>
        <MenuItem onClick={(ev) => this.handleClick(ev)}>
          <RefreshIndicator refresh={this.props.fetching} />
        </MenuItem>
        {hasSubtitles &&
            <MenuItem divider></MenuItem>
        }
        {hasSubtitles && subtitles.toIndexedSeq().map(function(subtitle, index) {
          return (
            <MenuItem key={index} href={subtitle.get("url")}>
              <i className="fa fa-download"></i> &nbsp;{subtitle.get("language").split("_")[1]}
            </MenuItem>
          );
        })}
      </DropdownButton>
    );
  }
}
